![Clarity](logo.png)

# Clarity Design System

[![Build Status](https://travis-ci.com/vmware/clarity.svg?branch=master)](https://travis-ci.com/vmware/clarity)

[![Build Status](https://saucelabs.com/browser-matrix/claritydesignsystem.svg)](https://saucelabs.com/beta/builds/b16110e384ce459ab68f10da6e38a285)

Project Clarity is an open source design system that brings together UX
guidelines, an HTML/CSS framework, Angular components, and Web Components. This
repository includes everything you need to build, customize, test, and deploy
Clarity. For complete documentation, visit the [Clarity website](https://clarity.design).

## Getting Started

Clarity is published as four npm packages:

* **[@clr/icons](https://www.npmjs.com/package/@clr/icons)** Contains the custom
  element icons.
* **[@clr/ui](https://www.npmjs.com/package/@clr/ui)** Contains the static
  styles for building HTML components.
* **[@clr/angular](https://www.npmjs.com/package/@clr/angular)** Contains the
  Angular components. This package depends on @clr/ui for styles.
* **[@clr/core](https://www.npmjs.com/package/@clr/core).** Contains the Web
  Components that work in any JavaScript framework.

## Installing Clarity

* **[Install CSS Only](/docs/INSTALLATION.md#installing-clarity-ui)**
* **[Install Icons](/docs/INSTALLATION.md#installing-clarity-icons)**
* **[Install Angular Components](/docs/INSTALLATION.md#installing-clarity-angular)**
* **[Install Web Components](/docs/INSTALLATION.md#installing-clarity-web-components)**

## Documentation

For documentation on the Clarity Design System, including a list of components
and example usage, see [our website](https://clarity.design).

## Contributing

The Clarity project team welcomes contributions from the community. For more
detailed information, see [CONTRIBUTING.md](CONTRIBUTING.md).

## Licenses

* The Clarity Design System is licensed under the MIT license.
* The font is licensed under the Open Font License (OFL).

## Feedback

If you find a bug or want to request a new feature, please open a [GitHub issue](https://github.com/vmware/clarity/issues).

Include a link to the reproduction scenario you created by forking one of the
Clarity Stackblitz Templates for the version you are using at
[Clarity StackBlitz templates](https://stackblitz.com/@clr-team/).
